10 REM A BASIC ADVENTURE WRITTEN BY PETER DASSOW
20 REM AS AN EXAMPLE HOW TO WRITE SUCH A GAME
30 REM PLEASE VISIT WWW.Z80.EU AND IT'S BLOG
40 CLS:PRINT "Peter's Adventure (Version 0.9)"
50 PRINT:PRINT "Type in commands like 'LOOK' or 'TAKE' to go on."
60 PRINT "A full list of commands can be shown with 'HELP'."
70 OPTION BASE 1
80 RANDOMIZE TIMER
90 DIM WORDS$(15),WAY$(6),SHOWCMD$(2),PARAM$(3),ITEMDESC$(10),WHAT$(12)
100 DIM INVENTORY$(10),INVTYPE$(10)
110 DIM MAP$(11,11)
120 MX%=11:MY%=11:REM MAXIMUM SIZE OF MAP, MUST CORRELATE WITH DIM MAP$ ABOVE !
130 STEPS%=0:REM INITIAL SUM OF STEPS
140 HEALTH%=20:REM INITIAL MAX HEALTH VALUE
150 MHEALTH%=20:REM INITIAL MONSTER HEALTH (ALL TYPES)
160 GATHERED%=0:REM INITIAL MUMBER OF ITEMS IN INVENTORY
170 MINV%=20:REM MAXIMUM ITEMS IN INVENTORY
180 FOR I%=1 TO 15:READ WORDS$(I%):NEXT I%
190 FOR I%=1 TO 6:READ WAY$(I%):NEXT I%
200 FOR I%=1 TO 2:READ SHOWCMD$(I%):NEXT I%
210 FOR I%=1 TO 10:READ ITEMDESC$(I%):NEXT I%
220 REM SETUP FOR ROOMS ON THE MAP
230 FOR X%=1 TO MX%:FOR Y%=1 TO MY%
240 READ MAP$(X%,Y%)
250 NEXT Y%:NEXT X%
260 YMAP%=2:XMAP%=3:REM START COORDINATES
270 REM MAIN INTERPRETER LOOP STARTS HERE:
280 GOSUB 2990:REM INPUT WORDS
290 IF HEALTH%<10 AND HEALTH%>0 THEN PRINT "You're not in best shape. Eat something. Prevent to be hurt."
300 IF HEALTH%<1 THEN PRINT "You're now dead. You had better eat something. Game ends.":PRINT:RESTORE:PRINT "Restart.":GOTO 120
310 GOSUB 3100:REM UPPERCASE
320 GOSUB 2900:REM SPLIT INTO SINGLE WORDS
330 REM DEBUG ONLY:
340 REM FOR I%=1 TO CW%
350 REM PRINT I%;":";PARAM$(I%);"."
360 REM NEXT I%
370 I%=1:VERB%=0
380 WHILE I%<=15
390 IF PARAM$(1)=WORDS$(I%) THEN VERB%=I%
400 I%=I%+1
410 WEND
420 IF VERB%=0 THEN PRINT "Don't know how to do this: ";CMD$:GOTO 280
430 REM WE KNOW THE COMMAND (AT LEAST THE FIRST WORD)
440 IF VERB%=1 THEN PRINT "Verbs are:";:FOR I%=1 TO 15:PRINT " ";WORDS$(I%);:NEXT I%:PRINT:GOTO 280
450 IF VERB%<>15 THEN 520
460 REM * COMMAND QUIT *
470 PRINT "Are you sure (Y/N)? ";
480 KY$=INKEY$:WHILE KY$="":KY$=INKEY$:WEND
490 PRINT KY$
500 IF KY$="y" OR KY$="Y" THEN PRINT "Ok. Goodbye.":END
510 IF KY$<>"n" AND KY$<>"N" THEN PRINT "What ?":GOTO 470
520 GOSUB 3160:GOSUB 3650:REM *** CHECK IF THERE IS SOMETHING HOSTILE ***
530 IF VERB%<>2 THEN 670
540 REM * COMMAND LOOK *
550 REM GOSUB 2970
560 REM TP%+1 contains number of map field items beginning from 1
570 REM Remember: Every second field item is NOT the word itself, instead the kind of item
580 FLIP%=0
590 FOR I%=1 TO TP%+1
600 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
610 IF FLIP%=1 THEN GOTO 650:REM Just the item name is not enough here, need to know if it's type 0
620 IF WHAT$(I%)="0" THEN PRINT "You see ";WHAT$(I%-1);"."
630 IF WHAT$(I%)="8" THEN PRINT "A ";WHAT$(I%-1);" attacks you."
640 IF WHAT$(I%)="9" THEN PRINT "A ";WHAT$(I%-1);" is waiting."
650 NEXT I%
660 GOTO 2860
670 IF VERB%<>3 AND VERB%<>4 THEN 1000
680 REM * COMMAND TAKE & GET *
690 REM
700 REM GOSUB 2970
710 REM TP%+1 contains number of map field items beginning from 1
720 REM Remember: Every second field item is NOT the word itself, instead the kind of item
730 FLIP%=0:TAKEN%=0
740 FOR I%=1 TO TP%+1
750 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
760 IF FLIP%=0 THEN 920:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
770 J%=I%:CMD$=WHAT$(I%):GOSUB 3100:I%=J%:REM You must save I% before using the subroutine
780 IF PARAM$(2)<>CMD$ THEN 920
790 IF WHAT$(I%+1)="0" OR WHAT$(I%+1)="8" OR WHAT$(I%+1)="9" OR WHAT$(I%+1)="10" THEN PRINT "This can't be taken.":I%=TP%+1:GOTO 920
800 IF GATHERED%>=MINV% THEN PRINT "Can't carry more.":I%=TP%+1:GOTO 920
810 PRINT "Taken !":TAKEN%=I%
820 GATHERED%=GATHERED%+1
830 INVENTORY$(GATHERED%)=PARAM$(2):INVTYPE$(GATHERED%)=WHAT$(I%+1)
840 IF WHAT$(I%+1)="1" THEN PRINT "But it's ";ITEMDESC$(1)
850 IF WHAT$(I%+1)="2" THEN PRINT "It's ";ITEMDESC$(2)
860 IF WHAT$(I%+1)="3" THEN PRINT "It's ";ITEMDESC$(3)
870 IF WHAT$(I%+1)="4" THEN PRINT "It's ";ITEMDESC$(4)
880 IF WHAT$(I%+1)="5" THEN PRINT "It's ";ITEMDESC$(5)
890 IF WHAT$(I%+1)="6" THEN PRINT "It's ";ITEMDESC$(6)
900 IF WHAT$(I%+1)="7" THEN PRINT "It's ";ITEMDESC$(7)
910 I%=TP%+1:REM LET THE LOOP END
920 NEXT I%
930 IF TAKEN%<1 THEN PRINT "There is no item like this.":GOTO 2860
940 REM Code here assumes an item is taken for sure
950 IF TAKEN%>0 AND (INVTYPE$(GATHERED%)="5" OR INVTYPE$(GATHERED%)="3") THEN FOUND%=TAKEN%:GOSUB 3320
960 REM
970 REM
980 GOTO 2860
990 REM * COMMAND DROP *
1000 IF VERB%<>5 THEN 1140
1010 PRINT "I'll try to drop ";PARAM$(2)
1020 SUCCESS%=0
1030 FOR I%=1 TO GATHERED%
1040 IF INVENTORY$(I%)<>PARAM$(2) THEN 1100
1050 PRINT "Ok, dropped.":SUCCESS%=1
1060 FOR J%=I% TO GATHERED%-1
1070 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1080 NEXT J%
1090 I%=GATHERED%:GATHERED%=GATHERED%-1
1100 NEXT I%
1110 IF SUCCESS%=0 THEN PRINT "Couldn't drop it."
1120 GOTO 2860
1130 REM * COMMAND EAT *
1140 IF VERB%<>6 THEN 1310
1150 REM Not without any paramter useful
1160 IF CW%<=1 THEN PRINT "What should I eat ?":GOTO 2860
1170 PRINT "Try to eat ";PARAM$(2)
1180 SUCCESS%=0
1190 FOR I%=1 TO GATHERED%
1200 IF INVENTORY$(I%)<>PARAM$(2) THEN 1280
1210 IF INVTYPE$(I%)<>"4" THEN I%=GATHERED%:GOTO 1280
1220 PRINT "Ok, I eat that. Health increased.":SUCCESS%=1
1230 FOR J%=I% TO GATHERED%-1
1240 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1250 NEXT J%
1260 I%=GATHERED%:GATHERED%=GATHERED%-1
1270 HEALTH%=HEALTH%+3:IF HEALTH%>20 THEN HEALTH%=20
1280 NEXT I%
1290 IF SUCCESS%=0 THEN PRINT "Are you sure this can be eaten ?"
1300 GOTO 2860
1310 REM * COMMAND KILL *
1320 IF VERB%<>7 THEN 1650
1330 IF CW%<=1 THEN PRINT "What should I kill ?":GOTO 2860
1340 PRINT "Try to kill ";PARAM$(2)
1350 REM GOSUB 2970:REM TP%+1 contains number of map field items beginning from 1
1360 FLIP%=0:FOUND%=0
1370 FOR I%=1 TO TP%+1
1380 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
1390 IF FLIP%=0 THEN 1420:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
1400 IF WHAT$(I%+1)<>"8" THEN 1420:REM ONLY "8" IS SOMETHING HOSTILE
1410 CMD$=WHAT$(I%):J%=I%:GOSUB 3100:I%=J%:IF CMD$=PARAM$(2) THEN FOUND%=I%
1420 NEXT I%
1430 IF FOUND%=0 THEN PRINT "Nothing like this can be killed...":GOTO 1630
1440 SUCCESS%=0
1450 PRINT "Looking for a weapon in inventory now."
1460 FOR I%=1 TO GATHERED%
1470 REM Looking first for a weapon within inventory
1480 REM PRINT "DEBUG INVENTORY:";INVENTORY$(I%);",";INVTYPE$(I%)
1490 IF INVTYPE$(I%)<>"2" AND INVTYPE$(I%)<>"3" THEN 1580
1500 PRINT "Using ";INVENTORY$(I%);" ...":SUCCESS%=1
1510 IF INVTYPE$(I%)="3" THEN PRINT "A better weapon.":MHEALTH%=MHEALTH%-10:REM A WEAPON KILLS BETTER, SUBSTRACT MORE ;-)
1520 FOR J%=I% TO GATHERED%-1
1530 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1540 NEXT J%
1550 I%=GATHERED%:GATHERED%=GATHERED%-1
1560 MHEALTH%=MHEALTH%-10:IF HEALTH%<1 THEN MHEALTH%=0
1570 IF MHEALTH%<1 THEN PRINT "You successfully killed ";PARAM$(2) ELSE PRINT "Still alive..."
1580 NEXT I%
1590 IF SUCCESS%=0 THEN PRINT "You have nothing which can be used as a weapon.":GOTO 1630
1600 IF MHEALTH%>0 THEN 1630
1610 GOSUB 3160:REM TP%+1 contains number of map field items beginning from 1
1620 GOSUB 3320
1630 REM Killing is not completely implemented, but already usable
1640 GOTO 2860
1650 REM * COMMAND RUN & GO *
1660 IF VERB%<>8 AND VERB%<>9 THEN 1940
1670 REM Evaluate where to go
1680 DIRECT%=0:MHEALTH%=20:REM Monsters are always alive if coords reached
1690 FOR I%=1 TO 6
1700 IF PARAM$(2)=WAY$(I%) THEN DIRECT%=I%
1710 NEXT I%
1720 IF DIRECT%=0 THEN PRINT "Don't know where this is ... (try a geographic direction)":GOTO 2860
1730 REM
1740 OLDY%=YMAP%:OLDX%=XMAP%:REM PRINT "DEBUG: Remembering old coords OLDY%=";OLDY%;",OLDX%=";OLDX%
1750 IF DIRECT%=1 THEN YMAP%=YMAP%-1:REM NORTH
1760 IF DIRECT%=2 THEN XMAP%=XMAP%+1:REM EAST
1770 IF DIRECT%=3 THEN YMAP%=YMAP%+1:REM SOUTH
1780 IF DIRECT%=4 THEN XMAP%=XMAP%-1:REM WEST
1790 IF YMAP%<1 OR XMAP%<1 OR YMAP%>MY% OR XMAP%>MX% THEN YMAP%=OLDY%:XMAP%=OLDX%:PRINT "Can't go there." ELSE STEPS%=STEPS%+1
1800 REM PRINT "DEBUG: New coords YMAP%=";YMAP%;",XMAP%=";XMAP%;" OLDY%=";OLDY%;",OLDX%=";OLDX%
1810 GOSUB 3160:REM TP%+1 contains number of map field items beginning from 1
1820 REM Remember: Every second field item is NOT the word itself, instead the kind of item
1830 FLIP%=0
1840 FOR I%=1 TO TP%+1
1850 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
1860 IF FLIP%=1 THEN GOTO 1890:REM FLIP%==1 means 1st of 2 parameter, but we need the 2nd parameter (type)
1870 IF WHAT$(I%)="0" THEN PRINT "You see ";WHAT$(I%-1);"."
1880 IF WHAT$(I%)="8" THEN PRINT "A ";WHAT$(I%-1);" attacks you."
1890 NEXT I%
1900 PRINT "That was your step #";STEPS%
1910 HEALTH%=HEALTH%-1
1920 GOTO 2860
1930 REM * COMMAND SHOW *
1940 IF VERB%<>10 THEN 2290
1950 REM
1960 REM Show without parameter means show all items (if existing)
1970 REM
1980 IF CW%<=1 THEN 2020
1990 IF PARAM$(2)=SHOWCMD$(1) THEN GOSUB 3550:GOTO 2860
2000 IF PARAM$(2)=SHOWCMD$(2) THEN GOSUB 3600:GOTO 2860
2010 PRINT "Don't know to show """;PARAM$(2);"""":GOTO 2860
2020 REM GOSUB 2970:REM TP%+1 contains number of map field items beginning from 1
2030 REM Remember: Every second field item is NOT the word itself, instead the kind of item
2040 FLIP%=0
2050 FOR I%=1 TO TP%+1
2060 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
2070 IF FLIP%<>1 THEN 2150:REM If not the 1st parameter then look for 2nd parameter
2080 IF WHAT$(I%+1)="0" THEN 2250:REM skip parameter with descriptions
2090 REM PRINT "DEBUG: WHAT$(";I%;")=";WHAT$(I%);", WHAT$(";I%+1;")=";WHAT$(I%+1);"."
2100 IF I%>TP% THEN PRINT "ERROR IN MAP DATA. ITEM TYPE VALUE MISSING.":END
2110 IF WHAT$(I%+1)="8" OR WHAT$(I%+1)="9" THEN PRINT "A ";
2120 IF WHAT$(I%+1)<>"7" THEN PRINT WHAT$(I%);
2130 GOTO 2250
2140 REM The following lines can be optimized by using ITEMDESC$(VAL(WHAT$(I%)))
2150 IF WHAT$(I%)="1" THEN PRINT "  ... ";ITEMDESC$(1);"."
2160 IF WHAT$(I%)="2" THEN PRINT "  ... ";ITEMDESC$(2);"."
2170 IF WHAT$(I%)="3" THEN PRINT "  ... ";ITEMDESC$(3);"."
2180 IF WHAT$(I%)="4" THEN PRINT "  ... ";ITEMDESC$(4);"."
2190 IF WHAT$(I%)="5" THEN PRINT "  ... ";ITEMDESC$(5);"."
2200 IF WHAT$(I%)="6" THEN PRINT "  ... ";ITEMDESC$(6);"."
2210 REM IF WHAT$(I%)="7" THEN PRINT "  ... ";ITEMDESC$(7);".":REM A key should not be seen immediately
2220 IF WHAT$(I%)="8" THEN PRINT "  ... ";ITEMDESC$(8);"."
2230 IF WHAT$(I%)="9" THEN PRINT "  ... ";ITEMDESC$(9);"."
2240 IF WHAT$(I%)="10" THEN PRINT "  ... ";ITEMDESC$(10);"."
2250 NEXT I%
2260 REM
2270 GOTO 2860
2280 REM * COMMAND MAP *
2290 IF VERB%<>11 THEN 2390
2300 PRINT "Let me show your position on the map:"
2310 FOR I%=1 TO MX%
2320 FOR J%=1 TO MY%
2330 IF YMAP%=I% AND XMAP%=J% THEN PRINT " * "; ELSE PRINT " _ ";
2340 NEXT J%
2350 PRINT
2360 NEXT I%
2370 GOTO 2860
2380 REM * COMMAND DRINK *
2390 IF VERB%<>12 THEN 2460
2400 PRINT "Drinking only rudimentary implemented."
2410 REM Not yet implemented to eval type 6 items
2420 HEALTH%=HEALTH%+1:IF HEALTH%>20 THEN HEALTH%=20
2430 REM Some coding here
2440 GOTO 2860
2450 REM
2460 IF VERB%<>13 THEN 2760
2470 REM * COMMAND GIVE *
2480 SUCCESS%=0
2490 FOR I%=1 TO TP%+1:IF WHAT$(I%)="9" THEN SUCCESS%=1
2500 NEXT I%:IF SUCCESS%=0 THEN PRINT "Nobody here who would take it.":GOTO 2860
2510 FOR I%=1 TO GATHERED%
2520 IF INVENTORY$(I%)<>PARAM$(2) THEN 2730
2530 IF INVTYPE$(I%)<>"5" THEN I%=GATHERED%:GOTO 2730
2540 PRINT "It's accepted as a payment.":SUCCESS%=1
2550 REM Now delete the given item from the inventory
2560 FOR J%=I% TO GATHERED%-1
2570 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
2580 NEXT J%
2590 I%=GATHERED%:GATHERED%=GATHERED%-1
2600 REM Now take the new item
2610 FLIP%=0:TAKEN%=0
2620 FOR K%=1 TO TP%+1
2630 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
2640 IF FLIP%=0 THEN 2700:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
2650 IF WHAT$(K%+1)<>"7" THEN 2700
2660 IF GATHERED%>=MINV% THEN PRINT "Can't carry more.":K%=TP%+1:GOTO 2700
2670 GATHERED%=GATHERED%+1
2680 INVENTORY$(GATHERED%)=WHAT$(K%):INVTYPE$(GATHERED%)=WHAT$(K%+1)
2690 PRINT "You got ";WHAT$(K%);" !":TAKEN%=K%:K%=TP%+1
2700 NEXT K%
2710 IF TAKEN%>0 THEN FOUND%=TAKEN%:GOSUB 3320
2720 REM
2730 NEXT I%
2740 REM
2750 GOTO 2860
2760 IF VERB%<>14 THEN 2820
2770 SUCCESS%=0:FOR I%=1 TO TP%+1:IF WHAT$(I%)="10" THEN SUCCESS%=1
2780 NEXT I%:IF SUCCESS%=0 THEN PRINT "Nothing can be unlocked here.":GOTO 2820
2790 FOUND%=0:FOR I%=1 TO GATHERED%:IF INVTYPE$(I%)="7" THEN PRINT "Using ";INVENTORY$(I%);" for unlocking...":FOUND%=1
2800 NEXT I%
2810 IF FOUND%=1 THEN PRINT "You found the treasure.":PRINT:PRINT "Congratulation ! You solved the mystery in ";STEPS%;" steps.":END
2820 REM - Do not delete this line (it's a GOTO target)
2830 REM
2840 REM Room for additional commands and the code for it
2850 REM
2860 GOTO 280:REM *** END OF MAIN INTERPRETER LOOP ***
2870 REM
2880 REM --- *** A lot of subroutines follow now! *** ---
2890 REM
2900 L%=LEN(CMD$):BW%=1
2910 CW%=1:REM START VALUE FOR NUMBER OF WORDS PER COMMAND
2920 FOR I%=1 TO L%
2930 IF MID$(CMD$,I%,1)<>" " THEN 2960
2940 PARAM$(CW%)=MID$(CMD$,BW%,I%-BW%):CW%=CW%+1:I%=I%+1:BW%=I%
2950 IF CW%>2 THEN I%=L%
2960 NEXT I%
2970 PARAM$(CW%)=MID$(CMD$,BW%,I%-BW%)
2980 RETURN
2990 REM SUBROUTINE INTERPRET COMMAND, ELIMINATING BLANKS
3000 INPUT "Command ";CMD$
3010 L%=LEN(CMD$):LK$="":NCMD$=""
3020 FOR I%=1 TO L%
3030 KY$=MID$(CMD$,I%,1)
3040 IF KY$=" " THEN IF LK$=" " THEN 3060
3050 NCMD$=NCMD$+KY$
3060 LK$=KY$
3070 NEXT I%
3080 CMD$=NCMD$
3090 RETURN
3100 REM SUBROUTINE UPCASE COMMAND
3110 FOR I%=1 TO LEN(CMD$)
3120 UC%=ASC(MID$(CMD$,I%,1)):IF UC%>96 AND UC%<123 THEN UC%=UC%-32
3130 MID$(CMD$,I%,1)=CHR$(UC%)
3140 NEXT I%
3150 RETURN
3160 REM SUBROUTINE SEPARATE ALL ITEMS OF MAP$ CONTENT AS SINGLE WORDS INTO WHAT$(INDEX)
3170 ITEMS$=MAP$(YMAP%,XMAP%)
3180 WP%=1:TP%=0
3190 L%=LEN(ITEMS$)
3200 FOR I%=1 TO L%
3210 IF MID$(ITEMS$,I%,1)<>"," THEN 3260
3220 TP%=TP%+1
3230 IF TP%>1 THEN NWORD$=MID$(ITEMS$,WP%+1,I%-WP%-1) ELSE NWORD$=MID$(ITEMS$,WP%,I%-WP%)
3240 WP%=I%
3250 WHAT$(TP%)=NWORD$
3260 NEXT I%
3270 IF TP%>=1 THEN WP%=WP%+1
3280 NWORD$=MID$(ITEMS$,WP%,I%-WP%+1)
3290 WHAT$(TP%+1)=NWORD$
3300 IF TP%+1<2 THEN PRINT "ERROR IN MAP TABLE DATA. NOT ENOUGH PARAMETER PER FIELD !":END
3310 RETURN
3320 REM SUBROUTINE DELETE ONE ITEM IN MAP$(INDEX), DEPENDING ON PARAMETER FOUND%
3330 DITEM%=0:FLIP%=0:REM PRINT "DEBUG: FOUND%=";FOUND%
3340 FOR I%=1 TO TP%+1
3350 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
3360 IF FLIP%=1 THEN 3440:REM skip 1st parameter
3370 REM FLIP%=0 STARTS HERE
3380 REM PRINT "DEBUG: WHAT$(";I%;")=";WHAT$(I%)
3390 IF WHAT$(I%)<>"8" AND WHAT$(I%)<>"5" AND WHAT$(I%)<>"3" AND WHAT$(I%)<>"7" THEN 3440:REM IF NOT POSSIBLE TO DELETE, SKIP
3400 REM PRINT "DEBUG: FOUND%=";FOUND%;" was I%-1=";I%-1;" ?"
3410 IF FOUND%<>I%-1 THEN 3440
3420 REM PRINT "DEBUG: Have to delete the item ";FOUND%;" in the map field."
3430 DITEM%=FOUND%
3440 NEXT I%
3450 IF DITEM%=0 THEN 3540
3460 ITEMS$=""
3470 FOR I%=1 TO TP%+1
3480 IF DITEM%=I% THEN I%=I%+1:GOTO 3500:REM SKIP 2 ITEMS IN LIST
3490 ITEMS$=ITEMS$+WHAT$(I%)+","
3500 NEXT I%
3510 IF RIGHT$(ITEMS$,1)="," THEN ITEMS$=LEFT$(ITEMS$,LEN(ITEMS$)-1)
3520 MAP$(YMAP%,XMAP%)=ITEMS$:REM PRINT "DEBUG: ITEMS$()=";ITEMS$
3530 REM
3540 RETURN
3550 REM SUBROUTINE SHOW INVENTORY
3560 FOR I%=1 TO GATHERED%
3570 PRINT INVENTORY$(I%);" (";ITEMDESC$(VAL(INVTYPE$(I%)));")"
3580 NEXT I%
3590 RETURN
3600 REM SUBROUTINE SHOW STATUS
3610 PRINT "Steps already taken:";STEPS%
3620 PRINT "Health:";HEALTH%*5!;"%"
3630 PRINT "Free inventory slots:";MINV%-GATHERED%
3640 RETURN
3650 REM SUBROUTINE CHECK if something is hostile here
3660 FLIP%=0:FOUND%=0
3670 FOR I%=1 TO TP%+1
3680 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
3690 IF FLIP%=0 THEN 3720:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
3700 IF WHAT$(I%+1)<>"8" THEN 3720:REM ONLY "8" IS SOMETHING HOSTILE
3710 FOUND%=I%
3720 NEXT I%
3730 IF FOUND%=0 THEN 3770
3740 HEALTH%=HEALTH%-5:REM FROM 20 TAKE 5 (25%)
3750 PRINT "You were hurt !!!"
3760 IF HEALTH%<0 THEN HEALTH%=0
3770 RETURN
3780 REM 15 COMMAND KEYWORDS
3790 DATA "HELP","LOOK","TAKE","GET","DROP","EAT","KILL","RUN","GO"
3800 DATA "SHOW","MAP","DRINK","GIVE","UNLOCK","QUIT"
3810 REM 6 COMMAND PARAMETER FOR GO,RUN AND LOOK
3820 DATA "NORTH","EAST","SOUTH","WEST","UP","DOWN"
3830 REM 2 COMMAND PARAMETER FOR SHOW
3840 DATA "INVENTORY","STATUS"
3850 REM 9 ITEM TYPE DESCRIPTIONS
3860 DATA "nothing special"
3870 DATA "may be an item to hurt something"
3880 DATA "may be an item to kill something for sure"
3890 DATA "may be something to eat"
3900 DATA "may be helpful for paying something"
3910 DATA "may be something to drink"
3920 DATA "may be to unlock something"
3930 DATA "hostile"
3940 DATA "may be you can something buy here"
3950 DATA "a surprise is waiting for you"
3960 REM 
3970 REM MAP CONTENT (A HORIZONTAL LINE HAVE 11 TILES)
3980 REM 1
3990 DATA "Grass,1,the border,0"
4000 DATA "Plants,1,the border,0"
4010 DATA "Grass,1,the border,0"
4020 DATA "Grass,1,Plants,1,the border,0"
4030 DATA "Grass,1,the border,0"
4040 DATA "Grass,1,Plants,1,the border,0"
4050 DATA "Grass,1,the border before an error,0"
4060 DATA "Grass,the border,0"
4070 DATA "Grass,1,the border,0"
4080 DATA "Grass,1,the border,0"
4090 DATA "Grass,1,the border,0"
4100 REM 2
4110 DATA "Grass,1,the border,0"
4120 DATA "Grass,1,grassland,0"
4130 DATA "Grass,1,Stones,2,Plants,1,stony ground,0"
4140 DATA "Grass,1,Stones,2,grassland with stones,0"
4150 DATA "Grass,1,Insects,1"
4160 DATA "Grass,1,Trees,1,Nuts,4,a forest,0"
4170 DATA "Grass,1,Trees,1,Nuts,4,a forest,0"
4180 DATA "Grass,1,Trees,1,Nuts,4,a forest,0"
4190 DATA "Grass,1,Trees,1,Nuts,4,Stones,2,a forest and stones,0"
4200 DATA "Grass,1,Stones,2,Gold,5,stony grassland,0"
4210 DATA "Grass,1,Stones,2,Gold,5,the border and stony grassland,0"
4220 REM 3
4230 DATA "Grass,1,the border,0"
4240 DATA "Grass,1,grassland,0"
4250 DATA "Grass,1,grassland,0"
4260 DATA "Knife,3,a place,0,grass,1,some grass,0"
4270 DATA "Grass,1,Insects,1,grassland,0"
4280 DATA "Grass,1,Berries,4,grass and bushes,0"
4290 DATA "Grass,1,Berries,4,grass and bushes,0"
4300 DATA "Grass,1,Berries,4,grass and bushes,0"
4310 DATA "Grass,1,Trees,1,Apple,4,a forest,0"
4320 DATA "Grass,1,Bush,1,Berries,4,grassland and a bush,0"
4330 DATA "Grass,1,the border and grassland,0"
4340 REM 4
4350 DATA "Grass,1,the border,0"
4360 DATA "Grass,1,grassland,0"
4370 DATA "Rocks,3,stony ground,0"
4380 DATA "Stones,2,stony ground,0"
4390 DATA "Grass,1,grassland,0"
4400 DATA "Grass,1,grassland,0"
4410 DATA "Grass,1,grassland,0"
4420 DATA "Grass,1,Bush,1,Berries,4,bushes and a few trees,0"
4430 DATA "Grass,1,grassland,0"
4440 DATA "Grass,1,grassland,0"
4450 DATA "Grass,1,the border,0"
4460 REM 5
4470 DATA "Grass,1,the border,0"
4480 DATA "Grass,1,grassland,0"
4490 DATA "Rocks,3,stony ground,0"
4500 DATA "Grass,1,man,8,a house and around grass,0"
4510 DATA "Grass,1,grassland,0"
4520 DATA "Grass,1,grassland,0"
4530 DATA "Grass,1,grassland,0"
4540 DATA "Water,6,a small lake,0"
4550 DATA "Grass,1,grassland,0"
4560 DATA "Grass,1,grassland,0"
4570 DATA "Grass,1,the border,0"
4580 REM 6
4590 DATA "Grass,1,the border,0"
4600 DATA "Grass,1,grassland,0"
4610 DATA "Rocks,3,stony ground,0"
4620 DATA "Grass,1,Wood,2,Chocolate,4,a fence and much grass,0"
4630 DATA "Grass,1,grassland,0"
4640 DATA "Grass,1,Sword,3,grassland,0"
4650 DATA "Grass,1,Gold,5,grassland,0"
4660 DATA "Grass,1,Leafes,1,monster,8,grassland with bushes,0"
4670 DATA "Grass,1,grassland and a tent with a merchant,0,Key,7,merchant,9"
4680 DATA "Grass,1,grassland,0"
4690 DATA "Grass,1,the border,0"
4700 REM 7
4710 DATA "Grass,1,the border,0"
4720 DATA "Grass,1,grassland,0"
4730 DATA "Rocks,3,stony ground,0"
4740 DATA "Grass,1,grassland,0"
4750 DATA "Grass,1,grassland,0"
4760 DATA "Grass,1,grassland,0"
4770 DATA "Grass,1,grassland,0"
4780 DATA "Grass,1,grassland,0,Sword,3"
4790 DATA "Grass,1,grassland and a small hut,0,Chest,10"
4800 DATA "Grass,1,grassland,0"
4810 DATA "Grass,1,the border,0"
4820 REM 8
4830 DATA "Grass,1,the border,0"
4840 DATA "Grass,1,grassland,0"
4850 DATA "Rocks,3,stony ground,0"
4860 DATA "Grass,1,grassland and an apple tree,0,Apple,4"
4870 DATA "Grass,1,grassland,0"
4880 DATA "Grass,1,grassland,0"
4890 DATA "Grass,1,grassland,0"
4900 DATA "Grass,1,grassland,0"
4910 DATA "Grass,1,grassland,0"
4920 DATA "Grass,1,grassland,0"
4930 DATA "Grass,1,the border,0"
4940 REM 9
4950 DATA "Grass,1,the border,0"
4960 DATA "Grass,1,grassland,0"
4970 DATA "Rocks,3,stony ground,0"
4980 DATA "Grass,1,grassland,0"
4990 DATA "Grass,1,grassland,0"
5000 DATA "Grass,1,grassland,0"
5010 DATA "Grass,1,grassland,0"
5020 DATA "Grass,1,grassland,0"
5030 DATA "Grass,1,grassland,0"
5040 DATA "Grass,1,grassland,0"
5050 DATA "Grass,1,the border,0"
5060 REM 10
5070 DATA "Grass,1,the border,0"
5080 DATA "Grass,1,grassland,0"
5090 DATA "Rocks,3,stony ground,0"
5100 DATA "Grass,1,grassland,0"
5110 DATA "Grass,1,grassland,0"
5120 DATA "Grass,1,grassland,0"
5130 DATA "Grass,1,grassland,0"
5140 DATA "Grass,1,grassland,0"
5150 DATA "Grass,1,grassland,0"
5160 DATA "Grass,1,grassland,0"
5170 DATA "Grass,1,the border,0"
5180 REM 11
5190 DATA "Grass,1,the border,0"
5200 DATA "Grass,1,the border,0"
5210 DATA "Rocks,3,the border,0"
5220 DATA "Grass,1,the border,0"
5230 DATA "Grass,1,the border,0"
5240 DATA "Grass,1,the border,0"
5250 DATA "Grass,1,the border,0"
5260 DATA "Stones,2,the border,0"
5270 DATA "Grass,1,the border,0"
5280 DATA "Grass,1,the border,0"
5290 DATA "Grass,1,the border,0"
5300 REM LAST LINE JUST FOR TESTING PURPOSE
5310 SAVE "E:\Alte Rechner Dateien\PADVENT.BAS",A
